//  TopMess/L is a bulletinmaker program for the BBBS bulletin board system.
//  Copyright 1997 (c) The Errors.
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
//  The Errors can be reached at:
//
//           Errors HQ BBBS                        E-Mail
//     node 1: 47-56350198 (28k8)        Boogie/ERS : bgk@errors.bbs.no
//     node 3: 47-56341030 (33k6)        Soda/ERS   : soda@bgnett.no
//     node 4: 47-56341031 (64k0)
//

#include <stdio.h>

#define num_active    17
#define num_notwanted 2
#define true  1
#define false 0
#define version "v1.4"

#define NOCOL 36
#define NAMECOL 35
#define MSGCOL 32

#define HOWD
#define LINUX

struct one_user
{
  char         name[30];
  unsigned long msg_left;
};

struct one_user most_active[num_active];
#ifdef HOWD
  unsigned char usr_buffer[273];
#else
  unsigned char usr_buffer[239];
#endif
unsigned char not_wanted[num_notwanted][30];


FILE *open_file(char *filename)
{
  FILE *fhandle;

  if (!(fhandle=fopen(filename,"rb")))
    return(false);
  return(fhandle);
}


int read_one_user(FILE *fh_usr, char *usr_buffer)
{
  if (!feof(fh_usr))
  {
#ifdef HOWD
    fread(usr_buffer,273,1,fh_usr);
#else
    fread(usr_buffer,239,1,fh_usr);
#endif
    return(true);
  }
  return(false);
}

void clear_active()
{
  int t;

  for(t=0;t>num_active;t++)
  {
   most_active[t].name[0]='\0';
   most_active[t].msg_left=0;
  }
}

void read_unwanted(FILE *fil)
{
  int t=0;
  unsigned char *tmp;

  while (!feof(fil) && (t<num_notwanted))
  {
    fgets(&not_wanted[t][0],30,fil);
    tmp=strchr(&not_wanted[t++][0],'\n');
    *tmp='\0';
  }
}

int unwanted(FILE *data)
{
  int t;

  if (!data) return(false);
  for(t=0;t<num_notwanted;t++)
#ifdef LINUX
    if (strcasecmp(&not_wanted[t][0],&usr_buffer[0])==0)
#else
    if (strcmpi(&not_wanted[t][0],&usr_buffer[0])==0)
#endif
      return(true);
  return(false);
}

void insert_beforenode(int offset)
{
  int t,i;

  for(t=num_active-1;t>offset;t--)
  {
    for (i=0;i<30;i++)
      most_active[t].name[i]=most_active[t-1].name[i];
    most_active[t].msg_left=most_active[t-1].msg_left;
  }
  for (i=0;i<30;i++)
    most_active[offset].name[i]=usr_buffer[i];
#ifdef HOWD
  most_active[offset].msg_left=usr_buffer[169]+(usr_buffer[170]*256)+(usr_buffer[171]*256*256)+(usr_buffer[172]*256*256*256);
#else
  most_active[offset].msg_left=usr_buffer[157]+(usr_buffer[158]*256);
#endif
}

write_bull()
{
  int t;

  printf("\e[2J\e[0;0H\e[1;31mT\e[0;31mop\e[1mM\e[0;31mess\e[1m/\e[0;31mL \e[1;32m%s \e[30m(c) 1997 The Errors\r\n\r\n",version);
  printf("              \e[1;%umN\e[0;%umo  \e[1;%umN\e[0;%umame                                      \e[1;%umM\e[0;%umsgs\r\n", NOCOL, NOCOL, NAMECOL, NAMECOL, MSGCOL, MSGCOL);
  printf("              \e[1;30m--  ---------------------------------------- -----\r\n");
  for(t=0;t<num_active;t++)
    printf("              \e[1;%um%2d  \e[%um%-40s \e[%um%5d\r\n", NOCOL, t+1, NAMECOL, most_active[t].name, MSGCOL, most_active[t].msg_left);
  printf("\e[0m\r\n");
}


int main(int argc, char *argv[])
{

  FILE *fh_usr, *fh_not;
  unsigned int msg_count;
  int t;

  if (argc==2)
    if (strcmp(argv[1],"-V")==0)
    {
      printf("\nTopMess/L %s. Copyright 1997 (c) The Errors\n",version);
      printf("Free Software under GNU General Public License. NO WARRANTY.\n\n");
      return(1);
    }
  if (argc>=4 || argc==1)
  {
    printf("\nUsage: topmess [-V] [user_rec_filename] [unwanted_filename]\n\n");
    return(1);
  }

  if(!(fh_usr=open_file(argv[1])))
  {
    printf("\nERRORS 1: Can't open the file '%s'.\n\n",argv[1]);
    return(-1);
  }
  if(argc==3)
    if(!(fh_not=open_file(argv[2])))
    {
      printf("\nERRORS 1: Can't open the file '%s'.\n\n",argv[2]);
      return(-1);
    }

  clear_active();
  if (fh_not) read_unwanted(fh_not);
  while(read_one_user(fh_usr, usr_buffer))
  { 
    if ((usr_buffer[142]==0) && (unwanted(fh_not)==false))
    {
#ifdef HOWD
      msg_count=usr_buffer[169]+(usr_buffer[170]*256)+(usr_buffer[171]*256*256)+(usr_buffer[172]*256*256);
#else
      msg_count=usr_buffer[157]+(usr_buffer[158]*256);
#endif
      if (msg_count!=0)
      {
        for (t=0;t<num_active;t++)
        {
          if (msg_count>=most_active[t].msg_left)
          {
            insert_beforenode(t);
            break;
          }
        }
      }
    }
  }
  write_bull();
  fclose(fh_usr);
  if (argc==3)
    fclose(fh_not);
  return(0);
}
