//  TopUser/L is a bulletinmaker program for the BBBS bulletin board system.
//  Copyright 1997 (c) The Errors.
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
//  The Errors can be reached at:
//
//           Errors HQ BBBS                        E-Mail
//     node 1: 47-56350198 (28k8)        Boogie/ERS : bgk@errors.bbs.no
//     node 3: 47-56341030 (33k6)        Soda/ERS   : soda@bgnett.no
//     node 4: 47-56341031 (64k0)
//

#include <stdio.h>
#include <time.h>

#define num_active 15
#define num_notwanted 2
#define v_timeson 1
#define v_msg_left 3
#define v_uploaded 5
#define v_downloaded -2
#define true  1
#define false 0
#define version "v1.4"

#define HCOLA 32
#define HCOLB 36
#define NOCOL 32
#define NCOL 34
#define CCOL 36
#define MCOL 35
#define UCOL 37
#define DCOL 33
#define PCOL 31

#define HOWD
#define LINUX

struct one_user
{
  char           name[30];          //   0
  unsigned long  timeson,           // 155.w 161.l
                 msg_left,          // 157.w 169.l
                 uploaded,          // 159.w 193.l
                 downloaded;        // 161.w 201.l
  signed long    points;
};

struct one_user most_active[num_active];
#ifdef HOWD
  unsigned char usr_buffer[273];
#else
  unsigned char usr_buffer[239];
#endif
unsigned char not_wanted[num_notwanted][30];
signed long points;
int total_users=0;                 // total active users minus not_wanted users
int total_shown=0;                 // actual number of shown users

FILE *open_file(char *filename)
{
  FILE *fhandle;

  if (!(fhandle=fopen(filename,"rb")))
    return(false);
  return(fhandle);
}


int read_one_user(FILE *fh_usr, char *usr_buffer)
{
  if (!feof(fh_usr))
  {
#ifdef HOWD
    fread(usr_buffer,273,1,fh_usr);
#else
    fread(usr_buffer,239,1,fh_usr);
#endif
    return(true);
  }
  return(false);
}

void clear_active()
{
  int t;

  for(t=0;t>num_active;t++)
  {
   most_active[t].name[0]='\0';
   most_active[t].timeson=0;
   most_active[t].msg_left=0;
   most_active[t].uploaded=0;
   most_active[t].downloaded=0;
   most_active[t].points=0;
  }
}

void read_unwanted(FILE *fil)
{
  int t=0;
  unsigned char *tmp;

  while (!feof(fil) && (t<num_notwanted))
  {
    fgets(&not_wanted[t][0],30,fil);
    tmp=strchr(&not_wanted[t++][0],'\n');
    *tmp='\0';
  }
}

int unwanted(FILE *data)
{
  int t;

  if (!data) return(false);
  for(t=0;t<num_notwanted;t++)
#ifdef LINUX
    if (strcasecmp(&not_wanted[t][0],&usr_buffer[0])==0)
#else
    if (strcmpi(&not_wanted[t][0],&usr_buffer[0])==0)
#endif
      return(true);
  return(false);
}

void insert_beforenode(int offset)
{
  int t,i;

  for(t=num_active-1;t>offset;t--)
  {
    for (i=0;i<30;i++)
      most_active[t].name[i]=most_active[t-1].name[i];
    most_active[t].timeson=most_active[t-1].timeson;
    most_active[t].msg_left=most_active[t-1].msg_left;
    most_active[t].uploaded=most_active[t-1].uploaded;
    most_active[t].downloaded=most_active[t-1].downloaded;
    most_active[t].points=most_active[t-1].points;
 
  }
  for (i=0;i<30;i++)
    most_active[offset].name[i]=usr_buffer[i];
#ifdef HOWD
  most_active[offset].timeson=usr_buffer[161]+(usr_buffer[162]*256)+(usr_buffer[163]*256*256)+(usr_buffer[164]*256*256*256);
  most_active[offset].msg_left=usr_buffer[169]+(usr_buffer[170]*256)+(usr_buffer[171]*256*256)+(usr_buffer[172]*256*256*256);
  most_active[offset].uploaded=usr_buffer[193]+(usr_buffer[194]*256)+(usr_buffer[195]*256*256)+(usr_buffer[196]*256*256*256);
  most_active[offset].downloaded=usr_buffer[201]+(usr_buffer[202]*256)+(usr_buffer[203]*256*256)+(usr_buffer[204]*256*256*256);
#else
  most_active[offset].timeson=usr_buffer[155]+(usr_buffer[156]*256);
  most_active[offset].msg_left=usr_buffer[157]+(usr_buffer[158]*256);
  most_active[offset].uploaded=usr_buffer[159]+(usr_buffer[160]*256);
  most_active[offset].downloaded=usr_buffer[161]+(usr_buffer[162]*256);
#endif
  most_active[offset].points=points;
}

write_bull()
{
  int t;
  time_t time_now;

  time(&time_now); 
  printf("\e[2J\e[0;0H\e[1;31mT\e[0;31mop\e[1mU\e[0;31mser\e[1m/\e[0;31mL \e[1;32m%s \e[30m(c) 1997 The Errors\r\n\r\n",version);
  printf("    \e[0;%umTotal users: \e[%um%-5d \e[%umUsers listed: \e[%um%-4d \e[%umUpdated: \e[%um%s\r\n",HCOLA,HCOLB,total_users,HCOLA,HCOLB,total_shown,HCOLA,HCOLB,ctime(&time_now));  
  printf("    \e[1;%umN\e[0;%umo  \e[1;%umN\e[0;%umame                             \e[1;%umC\e[0;%umalls  \e[1;%umM\e[0;%umsgs   \e[1;%umU\e[0;%umpl   \e[1;%umD\e[0;%umwl     \e[1;%umP\e[0;%umoints\r\n",NOCOL,NOCOL,NCOL,NCOL,CCOL,CCOL,MCOL,MCOL,UCOL,UCOL,DCOL,DCOL,PCOL,PCOL);
  printf("    \e[1;30m--  -------------------------------- ----- ----- ----- ----- ----------\r\n");
  for(t=0;t<num_active;t++)
    printf("    \e[1;%um%2d  \e[%um%-32s \e[%um%5d \e[%um%5d \e[%um%5d \e[%um%5d \e[%um%10d\r\n",NOCOL,t+1,NCOL,most_active[t].name,CCOL,most_active[t].timeson,MCOL,most_active[t].msg_left,UCOL,most_active[t].uploaded,DCOL,most_active[t].downloaded,PCOL,most_active[t].points);
  printf("\e[0m\r\n");
}


int main(int argc, char *argv[])
{
  FILE *fh_usr, *fh_not;
  int t;


  if (argc==2)
    if (strcmp(argv[1],"-V")==0)
    {
      printf("\nTopUser/L %s. Copyright 1997 (c) The Errors\n",version);
      printf("Free Software under GNU General Public License. NO WARRANTY.\n\n");
      return(1);
    }
  if (argc>=4 || argc==1)
  {
    printf("\nUsage: topuser [-V] [user_rec_filename] [unwanted_filename]\n\n");
    return(1);
  }

  if(!(fh_usr=open_file(argv[1])))
  {
    printf("\nERRORS 1: Can't open the file '%s'.\n\n",argv[1]);
    return(-1);
  }
  if(argc==3)
    if(!(fh_not=open_file(argv[2])))
    {
      printf("\nERRORS 1: Can't open the file '%s'.\n\n",argv[2]);
      return(-1);
    }

  clear_active();
  if (fh_not) read_unwanted(fh_not);
  while(read_one_user(fh_usr, usr_buffer))
  { 
    if ((usr_buffer[142]==0) && (unwanted(fh_not)==false))
    {
      total_users++;
#ifdef HOWD
      points=((usr_buffer[161]+(usr_buffer[162]*256)+(usr_buffer[163]*256*256)+(usr_buffer[164]*256*256*256))*v_timeson)+((usr_buffer[169]+(usr_buffer[170]*256)+(usr_buffer[171]*256*256)+(usr_buffer[172]*256*256*256))*v_msg_left)+((usr_buffer[193]+(usr_buffer[194]*256)+(usr_buffer[195]*256*256)+(usr_buffer[196]*256*256*256))*v_uploaded)+((usr_buffer[202]+(usr_buffer[202]*256)+(usr_buffer[203]*256*256)+(usr_buffer[204]*256*256*256))*v_downloaded);
#else
      points=((usr_buffer[155]+(usr_buffer[156]*256))*v_timeson)+((usr_buffer[157]+(usr_buffer[158]*256))*v_msg_left)+((usr_buffer[159]+(usr_buffer[160]*256))*v_uploaded)+((usr_buffer[161]+(usr_buffer[162]*256))*v_downloaded);
#endif
      if (points>0)
      {
        for (t=0;t<num_active;t++)
        {
          if (points>=most_active[t].points)
          {
            if (total_shown<t+1) total_shown=t+1;
            insert_beforenode(t);
            break;
          }
        }
      }
    }
  }
  write_bull();
  fclose(fh_usr);
  if (argc==3) fclose(fh_not);
  return(0);
}
